#### EXPONENTIAL DISTRIBUTION ####
####################
## Create a syntetic dataset:

POPULATION<-rexp(10000000,rate = 2.4)
X<-sample(POPULATION,size = 500, replace = FALSE)

####################
n<-length(X)
lambda.mle<-n/sum(X)
se.lambda<-sqrt(lambda.mle^2/n)

hist(X, freq = FALSE, ylim=c(0,2))
curve(dexp(x, rate=lambda.mle), col="red", lwd=2, add=TRUE)


#### NORMAL DISTRIBUTION ####
####################
## Create a syntetic dataset:

POPULATION<-rnorm(10000000,mean=1, sd=sqrt(5))

X<-sample(POPULATION,size = 1000, replace = FALSE)



####################

n<-length(X)
mu.mle<-sum(X)/n
sigma2.mle<-sum((X-mu.mle)^2)/n

se.mu<-sqrt(sigma2.mle/n)
se.sigma2<-sqrt(2*(sigma2.mle)^2/n)

tab<-rbind(c(mu.mle,sigma2.mle),c(se.mu,se.sigma2))
colnames(tab)<-c("mu","sigma")
rownames(tab)<-c("Estimate","SE")


hist(X, freq = FALSE)
curve(dnorm(x, mean = mu.mle, sd=sqrt(sigma2.mle)), col="red", lwd=2, add=TRUE)


collect.mu.mle<-NULL
collect.sigma2.mle<-NULL
for(i in 1:1000){
  X<-sample(POPULATION,size = 1000, replace = FALSE)
  collect.mu.mle<-c(collect.mu.mle,sum(X)/n) 
  collect.sigma2.mle<-c(collect.sigma2.mle,sum((X-mu.mle)^2)/n)
}

mean(collect.mu.mle)
mean(collect.sigma2.mle)

plot(density(collect.mu.mle), main="Asymptotic Normality of MLE", xlab="mu")
plot(density(collect.sigma2.mle), main="Asymptotic Normality of MLE", xlab="sigma2")

#### POISSON DISTRIBUTION ####
####################
## Create a syntetic dataset:

POPULATION<-rpois(10000000,lambda = 5.7)
X<-sample(POPULATION,size = 500, replace = FALSE)

####################
n<-length(X)
lambda.mle<-sum(X)/n
se.lambda<-sqrt(lambda.mle/n)

hist(X, freq = FALSE, ylim=c(0,0.3))
points(seq(0,15),dpois(seq(0,15), lambda = lambda.mle), col="red", lwd=2, pch=9)






